
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>对象内存布局 (11) / iVAN</title>

    <meta name="description" content="对象内存布局 (11) 注意:关于内存对齐(memory alignment),请看关于内存对齐问题,后面将会用到.   下面我们进行在普通继承(即非虚继承)时,派生类的指针转换到基类指针的情形研究.假定各类之间的关系如下图:   代码如下: #include &lt;iostream&gt; using namespace std; class Parent { public: int parent; }; class Child : public Parent { public: int child; }; cla ...">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/bootstrap.css" rel="stylesheet">
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
  <script>
  var _hmt = _hmt || [];
  (function() {
    var hm = document.createElement("script");
    hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
    var s = document.getElementsByTagName("script")[0]; 
    s.parentNode.insertBefore(hm, s);
  })();
  </script>
 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="https://pic.ikafan.com/staticx/iamivan/2/assets/logo.png" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/">首页</a></li>
            <li><a href="/tag/互联网/">互联网</a></li>
            <li><a href="/tag/java/">java</a></li>
            <li><a href="/tag/mysql/">mysql</a></li>
            <li><a href="/tag/android/">Android</a></li>
            <li><a href="/tag/ios/">IOS</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    <div id="main" class="col-md-8">


<h1 class="mtitle">对象内存布局 (11)</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>

    	<section>
		<article class="clearfix">
		<p>注意：关于内存对齐(memory alignment)，请看<a href="http://blog.csdn.net/pathuang68/archive/2009/04/18/4088824.aspx" rel="external nofollow noreferrer">关于内存对齐问题</a>，后面将会用到。</p>
<p> </p>
<p>下面我们进行在普通继承(即非虚继承)时，派生类的指针转换到基类指针的情形研究。假定各类之间的关系如下图：</p>
<p> </p>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvcC5ibG9nLmNzZG4ubmV0L2ltYWdlcy9wX2Jsb2dfY3Nkbl9uZXQvcGF0aHVhbmc2OC9FbnRyeUltYWdlcy8yMDA5MDQyNC8xMjAxLkdJRg==.jpg"></p>
<p>代码如下：</p>
<pre>#include &lt;iostream&gt;
using namespace std;
class Parent
{
public:
    int parent;
};
class Child : public Parent
{
public:
    int child;
};
class GrandChild : public Child
{
public:
    int grandchild;
};
int main(void)
{
    Child* pc = new Child();
    GrandChild* pgc = new GrandChild();
    cout &lt;&lt; "1. The address of Child object:\t\t";
    cout &lt;&lt; (unsigned long*)pc &lt;&lt; endl;
    cout &lt;&lt; "2. The address of GrandChild object:\t";
    cout &lt;&lt; (unsigned long*)pgc &lt;&lt; endl;
    // 将类Child对象的指针pc，向上转型(upcast)到其父类型指针，即Parent*
    Parent* pp = (Parent*)pc;
    cout &lt;&lt; "3. Child* casted to Parent*:\t\t";
    cout &lt;&lt; (unsigned long*)pp &lt;&lt; endl;
    // 将类GrandChild对象的指针pgc，向上转型(upcast)到其父类型指针，即Child*
    Child* pc2 = (Child*)pgc;
    cout &lt;&lt; "4. GrandChild* casted to Child*:\t";
    cout &lt;&lt; (unsigned long*)pc2 &lt;&lt; endl;
    // 再将上面通过转型得到的类Child对象的指针pc2，向上转型(upcast)到其父类型指针，即Parent*
    Parent* pp2 = (Parent*)pc2;
    cout &lt;&lt; "5. Child* casted to Parent*:\t\t";
    cout &lt;&lt; (unsigned long*)pp2 &lt;&lt; endl;
    // 将类GrandChild对象的指针pgc，向上转型(upcast)到其祖类型指针，即Parent*
    Parent* pp3 = (Parent*)pgc;
    cout &lt;&lt; "6. GrandChild* casted to Parent*:\t";
    cout &lt;&lt; (unsigned long*)pp3 &lt;&lt; endl;
    return 0;
}</pre>
<p>运行结果：</p>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3lxZmlsZS5hbGljZG4uY29tL2ltZ185Mzg2NGEyMGNiOGJjZDkzYjY0YmQ0Yjg5OTM0OTUxMC5wbmc=.jpg"></p>
<p>我们发现在普通继承的情况下，将派生类对象的指针upcast为基类指针时，指针的值并不会发生改变。</p>
<p>比如上面输出中的1和3是一样的。</p>
<p>         Child* pc = new Child();             -&gt;               pc = 0x3d10e0</p>
<p>         Parent* pp = (Parent*)pc;           -&gt;               pp = 0x3d10e0</p>
<p>还有上面的2和4的输出也是一样的：</p>
<p>         GrandChild* pgc = new GrandChild();       -&gt;          pgc = 0x3d10f0</p>
<p>         Child* pc2 = (Child*)pgc;                        -&gt;          pc2 = 0x3d10f0</p>
<p>Grandchild的内存分布图：</p>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3lxZmlsZS5hbGljZG4uY29tL2ltZ185NDg4MGZmNTM1ZmM0ZjVmYjc0YzNjY2FlN2M2YjA0OC5wbmc=.jpg"></p>
<p>保持整个程序其他部分代码不做任何变动，我们将Child改为从Parent虚继承，改后的Child代码如下：</p>
<pre>#include &lt;iostream&gt;
using namespace std;
class Parent
{
public:
    int parent;
};
class Child : public virtual Parent
{
public:
    int child;
};
class GrandChild : public Child
{
public:
    int grandchild;
};
int main(void)
{
    Child* pc = new Child();
    GrandChild* pgc = new GrandChild();
    cout &lt;&lt; "1. The address of Child object:\t\t";
    cout &lt;&lt; (unsigned long*)pc &lt;&lt; endl;
    cout &lt;&lt; "2. The address of GrandChild object:\t";
    cout &lt;&lt; (unsigned long*)pgc &lt;&lt; endl;
    // 将类Child对象的指针pc，向上转型(upcast)到其父类型指针，即Parent*
    Parent* pp = (Parent*)pc;
    cout &lt;&lt; "3. Child* casted to Parent*:\t\t";
    cout &lt;&lt; (unsigned long*)pp &lt;&lt; endl;
    // 将类GrandChild对象的指针pgc，向上转型(upcast)到其父类型指针，即Child*
    Child* pc2 = (Child*)pgc;
    cout &lt;&lt; "4. GrandChild* casted to Child*:\t";
    cout &lt;&lt; (unsigned long*)pc2 &lt;&lt; endl;
    // 再将上面通过转型得到的类Child对象的指针pc2，向上转型(upcast)到其父类型指针，即Parent*
    Parent* pp2 = (Parent*)pc2;
    cout &lt;&lt; "5. Child* casted to Parent*:\t\t";
    cout &lt;&lt; (unsigned long*)pp2 &lt;&lt; endl;
    // 将类GrandChild对象的指针pgc，向上转型(upcast)到其祖类型指针，即Parent*
    Parent* pp3 = (Parent*)pgc;
    cout &lt;&lt; "6. GrandChild* casted to Parent*:\t";
    cout &lt;&lt; (unsigned long*)pp3 &lt;&lt; endl;
    return 0;
}</pre>
<p>运行结果：</p>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3lxZmlsZS5hbGljZG4uY29tL2ltZ18zMTk5MTBjN2ZhM2IxZTNiZGVkMTFlYzJjZGU4NGMyNy5wbmc=.jpg"></p>
<p>与上图相比较</p>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3lxZmlsZS5hbGljZG4uY29tL2ltZ185Mzg2NGEyMGNiOGJjZDkzYjY0YmQ0Yjg5OTM0OTUxMC5wbmc=.jpg"></p>
<p>现在来一一比较两者之间的不同：</p>
<p>第1条，两者相同；</p>
<p>第2条，两者相同；</p>
<p>第3条，由0x7d10e0变成了0x7d10e8了，也就是说经过Parent* pp = (Parent*)pc;后，即由pc = 0x7d10e0得到了pp = 0x7d10e8。很奇怪！</p>
<p>第4条，两者相同；</p>
<p>第5条，由0x7d10f8变成了0x7d1104了，也就是说经过Parent* pp2 = (Parent*)pc2;后，即由pc2 = 0x7d10f8得到了pp2 = 0x7d1104。很奇怪！</p>
<p>第6条，由0x7d10f8变成了0x7d1104了，也就是说经过Parent* pp3 = (Parent*)pgc;后，即由pgc = 0x7d10f8得到了pp3 = 0x7d1104。很奇怪！</p>
<p> </p>
<p>为什么会这样呢？通过上述分析发现，出现这种指针发生变化的情况，均发生在将Child*或者GrandChild*转换到Parent*的各行。Parent是Child的虚基类，Child又是GrandChild的基类。在上面的第4条中，我们通过Child* pc2 = (Child*)pgc;，试图将GrandChild*转换为Child*，事实上也转换成功了，同时指针的值并没有发生改变。GrandChild是普通继承于Child的，而非虚拟继承，换言之，Child不是GrandChild的虚基类，所以指针转换时，目标指针的值和赋给它的值保持一致。通过这样的分析我们似乎可以得出下面的结论：</p>
<p><strong>当一个派生类对象的指针转换到虚基类指针时(不管两者之间是否有其他中间类，而且也不管这些中间类是否是派生类的普通基类还是虚基类)，指针的值就会发生变化</strong>。</p>
<p>Child和Grandchild的内存分布图：</p>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3lxZmlsZS5hbGljZG4uY29tL2ltZ182NzgwMzJlM2NiMjE1NmU1NmY5OTJjMDY0ZWUxYjY3Zi5wbmc=.jpg"></p>
<p>为了验证上述结论，在上面的基础上，我们将GrandChild改为虚拟继承Child，修改后的GrandChild代码如下:</p>
<pre>#include &lt;iostream&gt;
using namespace std;
class Parent
{
public:
    int parent;
};
class Child : public virtual Parent
{
public:
    int child;
};
class GrandChild : public virtual Child
{
public:
    int grandchild;
};
int main(void)
{
    Child* pc = new Child();
    GrandChild* pgc = new GrandChild();
    cout &lt;&lt; "1. The address of Child object:\t\t";
    cout &lt;&lt; (unsigned long*)pc &lt;&lt; endl;
    cout &lt;&lt; "2. The address of GrandChild object:\t";
    cout &lt;&lt; (unsigned long*)pgc &lt;&lt; endl;
    // 将类Child对象的指针pc，向上转型(upcast)到其父类型指针，即Parent*
    Parent* pp = (Parent*)pc;
    cout &lt;&lt; "3. Child* casted to Parent*:\t\t";
    cout &lt;&lt; (unsigned long*)pp &lt;&lt; endl;
    // 将类GrandChild对象的指针pgc，向上转型(upcast)到其父类型指针，即Child*
    Child* pc2 = (Child*)pgc;
    cout &lt;&lt; "4. GrandChild* casted to Child*:\t";
    cout &lt;&lt; (unsigned long*)pc2 &lt;&lt; endl;
    // 再将上面通过转型得到的类Child对象的指针pc2，向上转型(upcast)到其父类型指针，即Parent*
    Parent* pp2 = (Parent*)pc2;
    cout &lt;&lt; "5. Child* casted to Parent*:\t\t";
    cout &lt;&lt; (unsigned long*)pp2 &lt;&lt; endl;
    // 将类GrandChild对象的指针pgc，向上转型(upcast)到其祖类型指针，即Parent*
    Parent* pp3 = (Parent*)pgc;
    cout &lt;&lt; "6. GrandChild* casted to Parent*:\t";
    cout &lt;&lt; (unsigned long*)pp3 &lt;&lt; endl;
    return 0;
}</pre>
<p>运行程序，得到如下结果：</p>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3lxZmlsZS5hbGljZG4uY29tL2ltZ183NjRiMjRhMzllOGM4ZDE3MjQ1NTEzMGU5MTdjNWM0Mi5wbmc=.jpg"></p>
<p>与上面两个图相比较：</p>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3lxZmlsZS5hbGljZG4uY29tL2ltZ185Mzg2NGEyMGNiOGJjZDkzYjY0YmQ0Yjg5OTM0OTUxMC5wbmc=.jpg"></p>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3lxZmlsZS5hbGljZG4uY29tL2ltZ18zMTk5MTBjN2ZhM2IxZTNiZGVkMTFlYzJjZGU4NGMyNy5wbmc=.jpg"></p>
<p>我们看到，现在第4条也发生了变化。因此原来的结论是成立的。再次总结一下这条非常重要的结论：</p>
<p>如果没有虚拟继承，当将派生类对象的指针转换到基类时(即使基类中有虚函数)，指针的值不会发生变化；但当一个派生类对象的指针转换到虚基类指针时(不管两者之间是否有其他中间类，而且也不管这些中间类是否是派生类的普通基类还是虚基类)，指针的值就会发生变化。</p>
<p> Grandchild的内存分布图：</p>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3lxZmlsZS5hbGljZG4uY29tL2ltZ185MGFhNWQwNzQ2OGViZjc3MDhmYjRiMmU0NWYxNWViOS5wbmc=.jpg"></p>
<p><strong>这个结论对后面的了解含有虚基类的对象内存布局有着非同一般的意义。</strong>对于这个结论，我们还剩下一个问题，那就是为什么会这样呢？ 前面我们可以看到赋值后的指针的值并不等于赋给它的对象地址值。也就是说在这个赋值过程中编译器进行了额外的工作，即调整了指针的值。我们看看上面程序中Parent* pp = (Parent*)pc; (向上类型转换，即up-casting) 这行对应的汇编代码(在VC中，进行debug时，按Alt 8，即可查看到汇编代码)，看看编译器究竟做了些什么？</p>
<pre>38:       Parent* pp = (Parent*)pc;

00401691   cmp         dword ptr [ebp-10h],0

00401695   jne          main+120h (004016a0)

00401697   mov         dword ptr [ebp-40h],0

0040169E   jmp         main+12Eh (004016ae)

004016A0   mov         eax,dword ptr [ebp-10h]

004016A3   mov         ecx,dword ptr [eax]                           // 6

004016A5   mov         edx,dword ptr [ebp-10h]                   // 7

004016A8   add         edx,dword ptr [ecx+4]                       // 8

004016AB   mov         dword ptr [ebp-40h],edx

004016AE   mov         eax,dword ptr [ebp-40h]

004016B1   mov         dword ptr [ebp-18h],eax</pre>
<p>重要的是第6、7、8行代码，它们通过偏移值指针找到偏移值，并以此来调整指针的位置，让目的指针最终指向对象中的基类部分的数据成员。</p>
<p> </p>
<p>至此，我们解释清楚了上面的问题。因为这部分讨论的结果太重要了，我们不妨再次总结如下：</p>
<p>如果没有虚拟继承，当将派生类对象的指针转换到基类时(即使基类中有虚函数)，指针的值不会发生变化；但当一个派生类对象的指针转换到虚基类指针时(不管两者之间是否有其他中间类，而且也不管这些中间类是否是派生类的普通基类还是虚基类)，<strong>指针(目的指针)的值就会发生变化，目的指针最终指向对象中的基类部分(或曰基类的实例)。</strong></p>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-03-05 08:25:28</div>
		
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong> <a href="https://www.iamivan.net/tag/%e5%b8%83%e5%b1%80/" title="布局">布局</a>, <a href="https://www.iamivan.net/tag/class/" title="class">class</a>, <a href="https://www.iamivan.net/tag/ptr/" title="PTR">PTR</a>        </div> -->
	</section>
	
	

		<div id="similar">

		<h3>对象内存布局 (11)的相关文章</h3>

								<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/bjj7Ldb.html" rel="bookmark">对象内存布局 &lpar;7&rpar;</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				在对象内存布局 (5)的代码中,在Derived类中覆盖Base1中声明的vfBase1_1(),其他代码不变.修改后的代码如下: #include &lt;iostream&gt; using namespace std; class Base1 { public: int m_base1; inline virtual void vfBase1_1() { cout &lt;&lt; &quot;This is in Base1::vfBase1_1()&quot; &lt;&lt; endl; }			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/pmj7K5z.html" rel="bookmark">对象内存布局 &lpar;6&rpar;</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				如果在对象内存布局 (5)的代码中,将Base1中的两个虚函数声明删除,同时将main函数中的下面代码注释掉(因为现在只有两张虚函数表了): 代码如下: #include &lt;iostream&gt; using namespace std; class Base1 { public: int m_base1; /*inline virtual void vfBase1_1() { cout &lt;&lt; &quot;This is in Base1::vfBase1_1()&quot; &lt;			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MqVLGZp.html" rel="bookmark">对象内存布局 &lpar;12&rpar;</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				下面来看看虚基类对对象内存布局的影响.虚基类的主要作用就是在所有的派生类中,保留且仅保留一份虚基类的suboject.   a. 一个虚基类的情况 #include &lt;iostream&gt; using namespace std; class Base { public: int base_member; }; class Derived : public virtual Base {}; int main(void) { Base b; Derived d; cout &lt;&lt; siz			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MvEK3Nb.html" rel="bookmark">对象内存布局 &lpar;10&rpar;</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				在对象内存布局 (9)基础上做些修改:派生类override基类的虚函数,即Base2 override Base1中声明的虚函数vfBase1(),Base3 override Base1中声明的虚函数vfBase1()和Base2中声明的虚函数vfBase2(), Derived override Base1中声明的虚函数vfBase1().Base2中声明的虚函数vfBase2()和Base3中声明的虚函数vfBase3().修改如下: #include &lt;iostream&gt; using			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/zGQjV3M.html" rel="bookmark">对象内存布局 &lpar;14&rpar;</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				前言 07年12月,我写了一篇&lt;C++虚函数表解析&gt;的文章,引起了大家的兴趣.有很多朋友对我的文章留了言,有鼓励我的,有批评我的,还有很多问问题的.我在这里一并对大家的留言表示感谢.这也是我为什么再写一篇续言的原因.因为,在上一篇文章中,我用了的示例都是非常简单的,主要是为了说明一些机理上的问题,也是为了图一些表达上方便和简单.不想,这篇文章成为了打开C++对象模型内存布局的一个引子,引发了大家对C++对象的更深层次的讨论.当然,我之前的文章还有很多方面没有涉及,从我个人感觉下来,在谈论虚函数			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/bQLrYrz.html" rel="bookmark">对象内存布局 &lpar;13&rpar;&mdash;&mdash;上一篇的纠正</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				下面来看看虚基类对对象内存布局的影响.虚基类的主要作用就是在所有的派生类中,保留且仅保留一份虚基类的suboject. #include &lt;iostream&gt; using namespace std; class Base { public: int m_base; Base():m_base(20){} virtual void vfBase_1() { cout &lt;&lt; &quot;This is in Base::vfBase_1()&quot; &lt;&lt; endl;			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/zZ4dGBM.html" rel="bookmark">对象内存布局 &lpar;15&rpar;</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				重复继承   下面我们再来看看,发生重复继承的情况.所谓重复继承,也就是某个基类被间接地重复继承了多次.   下图是一个继承图,我们重载了父类的f()函数.   其类继承的源代码如下所示.其中,每个类都有两个变量,一个是整形(4字节),一个是字符(1字节),而且还有自己的虚函数,自己overwrite父类的虚函数.如子类D中,f()覆盖了超类的函数, f1()和f2() 覆盖了其父类的虚函数,Df()为自己的虚函数. class B {     public:         int ib;  			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/zJ7jq6b.html" rel="bookmark">vs2008下C&plus;&plus;对象内存布局（3）：加上虚函数</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				这次我们为父类加上虚函数: class CParent { public: int parent_a; int parent_b; public: virtual void parent_f1() { parent_a = 0x10; } virtual void parent_f2() { parent_b = 0x20; } }; class CChild : public CParent { public: int child_a; int child_b; public: virtual			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MRYrlKb.html" rel="bookmark">对象内存布局 &lpar;1&rpar;</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				内容概要: 满足下面2个条件时, 1. 父类有虚函数,子类无虚函数(即无虚函数重写或无虚函数覆盖) 2. 非虚继承 类对象之内存布局   前述相关内容参考: 1. http://blog.csdn.net/pathuang68/archive/2009/04/20/4096088.aspx 2. http://blog.csdn.net/pathuang68/archive/2009/04/21/4096429.aspx 3. http://blog.csdn.net/pathuang68/ar			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/aM6QByb.html" rel="bookmark" class="title">创建和使用图表</a>
					<div>
						   图表是SQL Server 特有的一种数据库对象,它提供给用户直观的管理数据库表的方式.通过图表,用户可以直观地创建.编辑数据库表之间的关系,也可以编辑表及其列的属性.在Enterprise M ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/YbKO7nb.html" rel="bookmark" class="title">两台SQL Server服务器同步问题&period;</a>
					<div>
						server|服务器|问题 --定时同步服务器上的数据(服务器上的数据修改同步到本地)   --例子:  --测试环境,SQL Server2000,远程服务器名:rserver,用户名为:ruser ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/VMrx81z.html" rel="bookmark" class="title">初学Delphi嵌入汇编&lbrack;3&rsqb;</a>
					<div>
						前面知道了一个汇编的赋值指令(MOV), 再了解一个加法指令(ADD), 就可以做个例子 了. 譬如: ADD AX,BX; 这相当于 Delphi 中的 AX := AX + BX; 另外提前来个列 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/Myrr1lp.html" rel="bookmark" class="title">Javascript玩转继承（一）</a>
					<div>
						最近一直在学Javascript,打算写一些文章,算做自己的学习心得吧,也可以算是学习笔记.没有系统的知识点,太基础的不想写,主要是写一些自己觉得有价值的地方. 今天写第一篇. Javascript究 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MgKg2EM.html" rel="bookmark" class="title">photoshop鼠绘可爱的大眼女孩</a>
					<div>
						  最终效果 1.参考的原始图像. 2.确保遵循脸部曲线和光线描绘出大体轮廓.其实这步看图都知道怎么做.(注意:只需用两种颜色绘制,分出很多层,脸和脖子要在不同层上,调整透明度即可表现出渐变效果) 3 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MxPVV7M.html" rel="bookmark" class="title">WinXP系统定时关机命令使用技巧</a>
					<div>
						  首先,打开&quot;开始-运行&quot;,键入 shutdown /s /t 7200; 注意,其中7200是秒数,等于2小时.单击确定后,会出现如下对话框,显示倒计时; 取消定时关机的命令式 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pXjBoKb.html" rel="bookmark" class="title">windows2003 &plus; IIS6&period;0 环境下以Fastcgi方式配置php 5&period;3&period;3</a>
					<div>
						第一步:iis6.0环境配置,这里不多介绍 第二步:下载php5.3.3的windows压缩版本:php-5.3.3-nts-Win32-VC9-x86.zip 1.下载,选择VC9 x86 Non  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MAr69vp.html" rel="bookmark" class="title">Photoshop给绿篱边的美女加上唯美的淡冷色</a>
					<div>
						  素材图片为绿色,调色的时候可以直接把主色转为较为中性的褐色,然后用曲线等给图片暗部及高光区域增加蓝色,再把整体柔化处理即可. 原图 最终效果 1.打开素材图片,创建色相/饱和度调整图层,对黄色,绿 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pLaDRvz.html" rel="bookmark" class="title">风扇转速检测为0</a>
					<div>
						  在开机后,主板报警,提示系统监控发生错误,CPU散热风扇的转速为0.按任意键可以正常启动,正常工作. 打开机箱检查,发现启动过程中风扇正常工作.则怀疑是BIOS程序的问题,但清除CMOS内存后故障 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/b24qAvp.html" rel="bookmark" class="title">Storm中的可靠性</a>
					<div>
						     我们知道Storm有一个很重要的特性,那就是Storm API能够保证它的一个Tuple能够被完全处理,这一点尤为重要,其实storm中的可靠性是由spout和bolt组件共同完成的,下面就 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/b24N1kp.html" rel="bookmark" class="title">如何搭建直播平台？低延时连麦&plus;人工智能让互动升级</a>
					<div>
						2016年是直播平台爆发增长的一年,直播领域不断有新应用进入,其他垂直领域也纷纷加入直播功能.为了快速切入行业,掌握市场先机,绝大部分公司都选择了用视频云厂商的解决方案来促成业务能力的快速实现,如同快 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pLawN0z.html" rel="bookmark" class="title">用UITextView模拟UITextField的placeHolder</a>
					<div>
						用UITextView模拟UITextField的placeHolder 效果: 源码: // // ViewController.m // TextView // // Created by You ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M0Wk9mb.html" rel="bookmark" class="title">线上PHP问题排查思路与实践</a>
					<div>
						前言 前几天,在一淘网,腾讯网媒和微博商业技术联合组织的技术分享大会上,我分享了&lt;在线PHP问题排查思路与实践&gt;.此博文除了对PPT提供下载外,还会对ppt做简单的注释说明.主题分为三部分 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M6NQ2LM.html" rel="bookmark" class="title">小米手机&OpenCurlyDoubleQuote;上&rdquo;春晚，意欲何为</a>
					<div>
						雷军和小米的&quot;口碑&quot;营销的红利基本消耗殆尽,也就是说,只靠小米和雷军自说自话,已吸引不了多少新用户,而且小米手机懒以起家的性价比也同样推动了优势,小米整体销量应该走到了下降趋势之中 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MW2o3rb.html" rel="bookmark" class="title">&lbrack;Qt教程&rsqb; 第38篇 网络（八）TCP（二）</a>
					<div>
						[Qt教程] 第38篇 网络(八)TCP(二) 楼主  发表于 2013-9-6 15:50:35 | 查看: 421| 回复: 3 TCP(二) 版权声明 该文章原创于作者yafeilinux,转载 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bE4gy3z.html" rel="bookmark" class="title">文档-flash cs6中 颜色中线性渐变的 流是什么意思？</a>
					<div>
						问题描述 flash cs6中 颜色中线性渐变的 流是什么意思? 打开flash cs6后,新建一个文档,点击&quot;椭圆工具&quot;,打开颜色工具面板, 颜色类型设为线性渐变,下面会有流的选 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/Mvmln8b.html" rel="bookmark" class="title">常见网络命令之traceroute命令一起其他常用命令</a>
					<div>
						备注:任何命令+/?就可以显示命令帮助,比如:ipconfig /?. traceroute命令 traceroute是UNIX系统中的名字,用来跟踪一个分组从源点到终点的路径.在Windows系统中 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pdRXo1b.html" rel="bookmark" class="title">oracle的字符集检查工具CSSCAN&lpar;一&rpar;</a>
					<div>
						使用CSSCAN 工具在源库检查数据. 指定扫描的schame,只能指定一个schame $ csscan \&quot;sys/@ as sysdba\&quot; LOG=/tmp/expchec ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/b2RAlob.html" rel="bookmark" class="title">李开复自曝患淋巴癌：既然遭遇坦然面对</a>
					<div>
						李开复微博截图凤凰科技讯9月6日消息,创新工场董事长兼CEO李开复李开复今日早晨8点07分在其认证微博中表示,称自己已经确认患淋巴癌,并 感谢网友祝福.李开复表示,&quot;看到评论里这么多 网友的 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MrXG1mz.html" rel="bookmark" class="title">Struts result param详细设置</a>
					<div>
						Xml代码   &lt;result type=&quot;json&quot;&gt;                   &lt;!-- 这里指定将被Struts2序列化的属性,该属性在actio ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/p8AXLoz.html" rel="bookmark" class="title">react-nati&period;&period;&period;-react-native   用android真机调试</a>
					<div>
						问题描述 react-native 用android真机调试 出现如下图所示,ip地址输入的是本机的ip地址加:8081还是这个错误-求救(?°????????ω°????????｀) 解决方案 ht ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M0Rkj8z.html" rel="bookmark" class="title">20分钟构建你自己的Linux发行版</a>
					<div>
						你想要构建自己的 Linux 发行版吗?不喜欢市面上现有的Linux发行版?你认为自己可以构建一款更好的发行版?你很幸运.我要在 20 分钟里面介绍如何构建一款发行版. 是的,你没有听错,就是 20  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MYXkJrb.html" rel="bookmark" class="title">老瓶装新酒</a>
					<div>
						问题描述 net程序员重新来过,,该如何上路呢,因为项目需要当了一年的项目经理,管理上去了,技能丢了,想捡起来,该如何开始呢??希望大家给些建议 解决方案 解决方案二:把以前的项目拿出来练练解决方案三 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/b3ZNkJz.html" rel="bookmark" class="title">厦门将打造云计算中心 各家庭都可受益</a>
					<div>
						厦门将打造&quot;云计算&quot;中心 政府.企业以及每个家庭都可受益 海峡导报讯 (记者 易福进)对于厦门及周边城市来说,在不久的将来,计算机应用有望变得&quot;更简便&quot;:可能不 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pn8xNZb.html" rel="bookmark" class="title">微软新搜索品牌上线自称强于google</a>
					<div>
						中介交易 http://www.aliyun.com/zixun/aggregation/6858.html&quot;&gt;SEO诊断 淘宝客 云主机 技术大厅 微软新的搜索品牌&quot;Bin ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/p5QoRRp.html" rel="bookmark" class="title">强者没落的警讯</a>
					<div>
						再伟大的企业,都有经营出错甚至走向衰亡的过程,这时的企业,也许浑然不自知,而不同没落阶段独有的警讯或许能引起企业的警惕. 文/吉姆·柯林斯,美国管理学家及畅销书作家 无论多么伟大,每个组织都很脆弱.没 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MAkddnz.html" rel="bookmark" class="title">使用JavaScript构建JSON格式字符串实现步骤&lowbar;javascript技巧</a>
					<div>
						如果你现在正在使用Restful API,并且你需要通过web项目来构建json格式字符串的响应,那么这篇文章将帮助你使用javascript来创建json格式字符串.这是非常有用的,我们将通过jQu ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MlmlYYp.html" rel="bookmark" class="title">网站优化-目标关键词优化法</a>
					<div>
						目标关键词优化法则 优秀的将军会在决定性地点集中兵力优势,对于SEO来说,决定性地点在哪里?当然是网站的主打关键词--目标关键词! 对同一个行业领域来讲,目标关键词不仅是自己网站的重心,同是也竞争者网 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/ze0Xwwp.html" rel="bookmark" class="title">网站赚钱：网上挣钱的中国站长们看过来</a>
					<div>
						自主创业:网上挣钱的中国站长们看过来-网站的主题和内容对于通过网络挣钱的很多中国站长来说,网站对搜索引擎的友好无疑是最重要的.首先,在策划网站之前,自己的兴趣是一方面,但是网站提供的内容是否是大众所需 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bQW3wZp.html" rel="bookmark" class="title">全球删链？谷歌须在各国执行欧洲遗忘权</a>
					<div>
						欧洲对于互联网市场的抑制和打压,远远超过了创新和发明.迄今为止,欧洲也没有出现任何一家家喻户晓的互联网公司.日前,针对谷歌的一条&quot;噩耗&quot;消息再度传出,欧盟可能把所谓的&quot;遗 ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>热搜</span>
		</div>
		<div class="box-content">
					</div>
	</div>


</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 iVAN        | info#iamivan.net        | 11 q. 0.028 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <!-- <script src="/assets/js/jquery.js"></script>
  <script src="/assets/js/bootstrap.min.js"></script> -->
  <div style=" display: none ";>
  </div>

<script src="/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
    </script>
</body>
</html>
